using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace RenameFiles
{
    class CleanFileName
    {

        private List<string> allDir = new List<string>();
        private int totDir;
        int contatore = 0;

        //ciclo ricorsivamente sulla root per memorizzarmi tutte le cartelle da utilizzare per la rename dei file
        private void getSubDir(string path)
        {
           
            foreach (string myDir in Directory.GetDirectories(path))
            {
                allDir.Add(myDir);
                getSubDir(myDir);

            }
        }


        //rinomino
        public CleanFileName(string pathCartella, string _oldString, string _newString, Boolean _check)
        {
            //mi creo l'oggetto necessario per recuperare la cartella e i suoi file
            allDir.Add(pathCartella);
            getSubDir(pathCartella);
            
            if (_check == true)
            {
                foreach (string pathFolder in allDir)
                {
                    DirectoryInfo path = new DirectoryInfo(pathFolder);

                    foreach (FileInfo nfile in path.GetFiles())
                    {
                        //creo la nuova naming del file
                        string fileRename = replaceFile(nfile.Name, _oldString, _newString);

                        //copio il nuovo file creato nella stessa cartella dei file originali
                        string newPathFile = Path.Combine(pathFolder, fileRename);
                        FileInfo mFile = nfile.CopyTo(newPathFile);

                        //elimino il vecchio file originale
                        nfile.Delete();
                        contatore++;
                    }
                }
            }
            else
            {
                DirectoryInfo path = new DirectoryInfo(pathCartella);

                foreach (FileInfo nfile in path.GetFiles())
                {
                    //creo la nuova naming del file
                    string fileRename = replaceFile(nfile.Name, _oldString, _newString);

                    //copio il nuovo file creato nella stessa cartella dei file originali
                    string newPathFile = Path.Combine(pathCartella, fileRename);
                    FileInfo mFile = nfile.CopyTo(newPathFile);

                    //elimino il vecchio file originale
                    nfile.Delete();
                }
            }

            returnFileRinominati();
            
        }

        public string replaceFile(string file,string oldString,string newString)
        { 
            string newFile = file.Replace(oldString,newString);
            return newFile;
        }

        public int returnFileRinominati()
        {
            return contatore;
        }


    }
}
